org.apache.tomcat.util.net

## Interface SSLUtil

All Known Implementing Classes:
  JSSESocketFactory

    public interface SSLUtil

### Method Summary

Methods
`void` `configureSessionContext(SSLSessionContext sslSessionContext)`
`SSLContext` `createSSLContext()`
`String[]` `getEnableableCiphers(SSLContext context)` Determines the SSL cipher suites that can be enabled, based on the configuration of the endpoint and the ciphers supported by the SSL implementation.
`String[]` `getEnableableProtocols(SSLContext context)` Determines the SSL protocol variants that can be enabled, based on the configuration of the endpoint and the ciphers supported by the SSL implementation.
`KeyManager[]` `getKeyManagers()`
`TrustManager[]` `getTrustManagers()`

### Method Detail

#### createSSLContext

    SSLContext createSSLContext()
                                throws Exception

Throws:
  `Exception`

#### getKeyManagers

    KeyManager[] getKeyManagers()
                                throws Exception

Throws:
  `Exception`

#### getTrustManagers

    TrustManager[] getTrustManagers()
                                    throws Exception

Throws:
  `Exception`

#### configureSessionContext

    void configureSessionContext(SSLSessionContext sslSessionContext)

#### getEnableableCiphers

    String[] getEnableableCiphers(SSLContext context)

Determines the SSL cipher suites that can be enabled, based on the configuration of the endpoint and the ciphers supported by the SSL implementation.

Parameters:
  `context` - An initialized context to obtain the supported ciphers from.
Returns:
  Array of SSL cipher suites that may be enabled (which may be empty if none of the specified ciphers are supported), or the defaults for the underlying SSL implementation if the endpoint configuration does not specify any ciphers.

#### getEnableableProtocols

    String[] getEnableableProtocols(SSLContext context)

Determines the SSL protocol variants that can be enabled, based on the configuration of the endpoint and the ciphers supported by the SSL implementation.

Parameters:
  `context` - An initialized context to obtain the supported protocols from.
Returns:
  Array of SSL protocol variants that may be enabled (which may be empty if none of the specified protocols are supported), or the defaults for the underlying SSL implementation if the endpoint configuration does not specify any protocols.